<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/22/2009 *
 * ===================                          Last change: 10/22/2009 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : install-functions.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Functions for installation procedure             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Funktionen fuer die Installationsroutine         *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Write the local config-local.php file from "template"
function doInstallWriteLocalConfig () {
	// Copy the config template and verify it
	copyFileVerified(postRequestParameter('spath') . 'inc/config-local.php.dist', getPath() . getCachePath() . 'config-local.php', 0644);

	// Ok, all done. So we can write the config data to the php files
	if (postRequestParameter('spath') != getPath()) changeDataInLocalConfigurationFile('SERVER-PATH', "setConfigEntry('PATH', '", "');", postRequestParameter('spath'), 0);
	if (postRequestParameter('burl')  != getUrl())  changeDataInLocalConfigurationFile('HOST-URL', "setConfigEntry('URL', '", "');", postRequestParameter('burl'), 0);
	changeDataInLocalConfigurationFile('MAIN-TITLE', "setConfigEntry('MAIN_TITLE', '", "');", postRequestParameter('title'), 0);
	changeDataInLocalConfigurationFile('SLOGAN', "setConfigEntry('SLOGAN', '", "');", postRequestParameter('slogan'), 0);
	changeDataInLocalConfigurationFile('WEBMASTER', "setConfigEntry('WEBMASTER', '", "');", postRequestParameter('email'), 0);
	changeDataInLocalConfigurationFile('NULLPASS-WARNING', "setConfigEntry('WARN_NO_PASS', '", "');", postRequestParameter('warn_no_pass'), 0);
	changeDataInLocalConfigurationFile('WRITE-FOOTER', "setConfigEntry('WRITE_FOOTER', '", "');", postRequestParameter('wfooter'), 0);
	changeDataInLocalConfigurationFile('BACKLINK', "setConfigEntry('ENABLE_BACKLINK', '", "');", postRequestParameter('blink'), 0);
	// @TODO DEACTIVATED: changeDataInLocalConfigurationFile('OUTPUT-MODE', "setConfigEntry('OUTPUT_MODE', '", "');", postRequestParameter('omode'), 0);
	changeDataInLocalConfigurationFile('MYSQL-HOST', "	'host'     => '", "',", postRequestParameter('mysql','host'), 0);
	changeDataInLocalConfigurationFile('MYSQL-DBASE', "	'dbase'    => '", "',", postRequestParameter('mysql','dbase'), 0);
	changeDataInLocalConfigurationFile('MYSQL-LOGIN', "	'login'    => '", "',", postRequestParameter('mysql','login'), 0);
	changeDataInLocalConfigurationFile('MYSQL-PASSWORD', "	'password' => '", "',", postRequestParameter('mysql','pass1'), 0);
	changeDataInLocalConfigurationFile('MYSQL-PREFIX', "setConfigEntry('_MYSQL_PREFIX', '", "');", postRequestParameter('mysql','prefix'), 0);
	changeDataInLocalConfigurationFile('TABLE-TYPE', "setConfigEntry('_TABLE_TYPE', '", "');", postRequestParameter('mysql','type'), 0);
	changeDataInLocalConfigurationFile('SMTP-HOSTNAME', "setConfigEntry('SMTP_HOSTNAME', '", "');", postRequestParameter('smtp_host'), 0);
	changeDataInLocalConfigurationFile('SMTP-USER', "setConfigEntry('SMTP_USER', '", "');", postRequestParameter('smtp_user'), 0);
	changeDataInLocalConfigurationFile('SMTP-PASSWORD', "setConfigEntry('SMTP_PASSWORD', '", "');", postRequestParameter('smtp_pass1'), 0);

	// Generate a long site key
	$siteKey = generatePassword(50);

	// And write it
	changeDataInLocalConfigurationFile('SITE-KEY', "setConfigEntry('SITE_KEY', '", "');", $siteKey, 0);

	// Script is now installed
	changeDataInLocalConfigurationFile('INSTALLED', "setConfigEntry('MXCHANGE_INSTALLED', '", "');", 'Y', 0);
}

// Adds a given template with content to install output stream
function addTemplateToInstallContent ($template, $content = array()) {
	// Load the template
	$out = loadTemplate($template, true, $content);

	// Add it to output
	addToInstallContent($out);
}

// Add it to install content
function addToInstallContent ($out) {
	// Set or add it...
	if (!isset($GLOBALS['install_content'])) {
		// Set it
		$GLOBALS['install_content'] = $out;
	} else {
		// Add it
		$GLOBALS['install_content'] .= $out;
	} // END - if
}

// Somewhat getter for installer content
function getInstallerContent () {
	// Is it here?
	if (isset($GLOBALS['install_content'])) {
		// Yes, then use it
		$content = $GLOBALS['install_content'];
	} else {
		// Nothing found, this needs fixing
		$content = displayMessage('{--INSTALLER_CONTENT_404--}', true);
	}

	// Return content
	return $content;
}

// Read a given SQL dump
function readSqlDump ($FQFN) {
	// Load the file
	$content = readFromFile($FQFN);

	// Remove some unwanted chars
	$content = str_replace("\r", '', $content);
	$content = str_replace("\n\n", "\n", $content);

	// Return the content
	return $content;
}

// [EOF]
?>
